/*
 * pwm-motor.c
 *
 *  Created on: Dec 10, 2018
 *      Author: corrado
 */

#include "stm32_unict_lib.h"
#include "encoder.h"
#include <stdio.h>

int main(void)
{
	CONSOLE_init();
	init_encoder();

	GPIO_init(GPIOA);
	GPIO_config_output(GPIOA, 11); // dir1
	GPIO_config_output(GPIOA, 12); // dir2

	GPIO_init(GPIOB);
	GPIO_config_output(GPIOB, 6); // pb6 come
	GPIO_config_alternate(GPIOB, 6, 2);//tim4 ch1

	TIM_init(TIM4);
	TIM_config_timebase(TIM4, 1, 4200);
	TIM_set(TIM4, 0);
	TIM_config_PWM(TIM4, 1);
	TIM4->CCR1 = 0;
	TIM_on(TIM4);

	start_encoder();

	// setup direzione
	GPIO_write(GPIOA, 11, 1);
	GPIO_write(GPIOA, 12, 0);

	TIM4->CCR1= 400;

	unsigned short last_ticks = read_encoder();

	for(;;) {
		delay_ms(50);
		unsigned short current_ticks = read_encoder();
		float speed = (current_ticks - last_ticks) / 0.05;
		printf("Speed = %f, Position = %d\n", speed, current_ticks);
		last_ticks = current_ticks;
	}
}
